﻿''楽にキャラクタの設定、移動を行うためのクラスです。
''キャラクタのクラスを作るときは、このクラスを継承すると便利です。

Imports DxLibDLL.DX

Public Class Sprite
    Dim fHandle As Integer      ''ハンドル
    Dim fX, fY As Double        ''位置
    Dim fW, fH As Double        ''サイズ
    Dim fHosei As Integer       ''位置補正をするか？(0のときは、補正せずに、Outプロパティを1にする)
    Dim fOut As Integer         ''外に出たかどうか？

    ''公開メソッド
    ''---描画
    Public Sub Draw()
        DrawGraph(fX, fY, fHandle, DTRUE)
    End Sub

    ''---移動
    Public Sub Move(pVX As Double, pVY As Double)
        fX = fX + pVX : fY = fY + pVY

        If fX < SCREEN_X Then
            If fHosei = 1 Then
                fX = SCREEN_X
            Else
                fOut = DTRUE
            End If
        End If

        If fX + fW > SCREEN_X + SCREEN_W Then
            If fHosei = 1 Then
                fX = SCREEN_X + SCREEN_W - fW
            Else
                fOut = DTRUE
            End If
        End If

        If fY < SCREEN_Y Then
            If fHosei = 1 Then
                fY = SCREEN_Y
            Else
                fOut = DTRUE
            End If
        End If

        If fY + fH > SCREEN_Y + SCREEN_H Then
            If fHosei = 1 Then
                fY = SCREEN_Y + SCREEN_H - fH
            Else
                fOut = DTRUE
            End If
        End If

    End Sub

    ''公開プロパティ
    ''---ハンドル
    Public Property Handle()
        Get
            Return fHandle
        End Get

        Set(value)
            fHandle = value

            ''ハンドルの画像から、サイズを設定する
            GetGraphSize(fHandle, fW, fH)
        End Set
    End Property

    ''---X位置
    Public Property X
        Get
            Return fX
        End Get

        Set(value)
            fX = value
        End Set
    End Property

    ''---Y位置
    Public Property Y
        Get
            Return fY
        End Get

        Set(value)
            fY = value
        End Set
    End Property

    ''---幅
    Public ReadOnly Property Width
        Get
            Return fW
        End Get
    End Property

    ''---高さ
    Public ReadOnly Property Height
        Get
            Return fH
        End Get
    End Property

    ''---位置補正をするかどうか
    Public Property Revise
        Get
            Return fHosei
        End Get

        Set(value)
            fHosei = value
        End Set
    End Property

    ''---外に出たか？
    Public ReadOnly Property Out
        Get
            Return fOut
        End Get
    End Property
End Class
